;;;=======================[ BreakObjects.lsp ]==============================
;;; Author: Copyright 2006-2008 Charles Alan Butler. Contact @  www.TheSwamp.org. Version:  2.1  Nov. 20,2008
;;; Purpose: Break All selected objects permitted objects are: lines, lwplines, plines, splines, ellipse, circles & arcs 
;;; Function  C:MyBreak -       DCL for selecting the routines
;;; Function  C:BreakAll -      Break all objects selected with each other
;;; Function  C:BreakwObject  - Break many objects with a single object
;;; Function  C:BreakObject -   Break a single object with other objects 
;;; Function  C:BreakWith -     Break selected objects with other selected objects
;;; Function  C:BreakTouching - Break objects touching selected objects
;;; Function  C:BreakSelected - Break selected objects with any objects that touch it 
;;; Revision 1.8 Added Option for Break Gap greater than zero
;;; NEW r1.9  C:BreakWlayer -   Break objects with objects on a layer
;;; NEW r1.9  C:BreakWithTouching - Break touching objects with selected objects
;;; Revision 2.0 Fixed a bug when point to break is at the end of object
;;; Revision 2.1 Fixed another bug when point to break is at the end of object
;;; Function  break_with  - main break function called by all others and returns a list of new enames, see C:BreakAll for an example of using the return list
;;; Requirements: objects must have the same z-value
;;; Restrictions: Does not Break objects on locked layers 
;;; Returns:  none
;;; THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY. ALL IMPLIED WARRANTIES OF FITNESS FOR ANY PARTICULAR PURPOSE AND OF MERCHANTABILITY ARE HEREBY DISCLAIMED.
;;; You are hereby granted permission to use, copy and modify this software without charge, provided you do so exclusively for
;;; your own use or for use by others in your organization in the performance of their normal duties, and provided further that
;;; the above copyright notice appears in all copies and both that copyright notice and the limited warranty and restricted rights
;;; notice below appear in all supporting documentation.
;=============================================== CAC HAM CHINH
;---------- HAM GOI HOP THOAI DE CHON KIEU CAT
(defun C:CDT()
 (setq DCL_ID (load_dialog "Cat_doi_tuong.dcl")) (setq han 4)
 (while (> han 1)
  (new_dialog "CATDT" DCL_ID)
  (set_tile "cat1" (setq cat1 "0")) (set_tile "cat2" (setq cat2 "0")) (set_tile "cat3" (setq cat3 "0")) (set_tile "cat4" (setq cat4 "0"))
  (set_tile "cat5" (setq cat5 "0")) (set_tile "cat6" (setq cat6 "0")) (set_tile "cat7" (setq cat7 "0")) (set_tile "cat8" (setq cat8 "0"))
  (mode_tile "thietke" 1)
  (action_tile "cat1" "(setq cat1 (get_tile \"cat1\"))")  (action_tile "cat2" "(setq cat2 (get_tile \"cat2\"))")
  (action_tile "cat3" "(setq cat3 (get_tile \"cat3\"))")  (action_tile "cat4" "(setq cat4 (get_tile \"cat4\"))")
  (action_tile "cat5" "(setq cat5 (get_tile \"cat5\"))")  (action_tile "cat6" "(setq cat6 (get_tile \"cat6\"))")
  (action_tile "cat7" "(setq cat7 (get_tile \"cat7\"))")  (action_tile "cat8" "(setq cat8 (get_tile \"cat8\"))")
  (action_tile "Cancel" "(done_dialog 0)")
  (action_tile "Accept" "(done_dialog 1)")
  (action_tile "help"   "(c:hdcdt)")
  (setq han (start_dialog))
  (cond ((and (= han 1) (= cat1 "1")) (princ "\nLenh: BreakAll\n")          (C:BreakAll))
        ((and (= han 1) (= cat2 "1")) (princ "\nLenh: BreakwObject\n")      (C:BreakwObject))
        ((and (= han 1) (= cat3 "1")) (princ "\nLenh: BreakObject\n")       (C:BreakObject))
        ((and (= han 1) (= cat4 "1")) (princ "\nLenh: BreakWith\n")         (C:BreakWith))
        ((and (= han 1) (= cat5 "1")) (princ "\nLenh: BreakTouching\n")     (C:BreakTouching))
        ((and (= han 1) (= cat6 "1")) (princ "\nLenh: BreakSelected\n")     (C:BreakSelected))
        ((and (= han 1) (= cat7 "1")) (princ "\nLenh: BreakWithTouching\n") (C:BreakWithTouching))
        ((and (= han 1) (= cat8 "1")) (princ "\nLenh: BreakWlayer\n")       (C:BreakWlayer))))
 (unload_dialog DCL_ID) (princ))
;---------- 1. Cat TAT CA doi tuong DUOC CHON (Break all objects selected with each other)
(defun C:BreakAll (/ cmd ss NewEnts AllEnts tmp)
  (command "_.undo" "_begin") (setq cmd (getvar "CMDECHO")) (setvar "CMDECHO" 0)
  (or Bgap (setq Bgap 0))									; default
  (initget 4) (if (setq tmp (getdist (strcat "\nChieu day lat cat <"(rtos Bgap)">: ")))		; no negative numbers
    (setq Bgap tmp))
  (prompt "\nLenh nay dung de: Cat tat ca doi tuong duoc chon.")
  (prompt "\nChon cac doi tuong muon cat roi...")						;  get objects to break
  (if (setq ss (ssget '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
     (setq NewEnts (Break_with ss ss nil Bgap)))						; ss2break ss2breakwith (flag nil = not to break with self) ; AllEnts (append NewEnts (vl-remove-if 'listp (mapcar 'cadr (ssnamex ss)))
  (setvar "CMDECHO" cmd) (command "_.undo" "_end") (princ))
;---------- 2. Cat CAC doi tuong DUOC CHON boi MOT doi tuong DUOC CHON khac (Break many objects with a single object)
(defun C:BreakWobject (/ cmd ss1 ss2 tmp)
  (command "_.undo" "_begin") (setq cmd (getvar "CMDECHO")) (setvar "CMDECHO" 0)
  (or Bgap (setq Bgap 0))									; default
  (initget 4) (if (setq tmp (getdist (strcat "\nChieu day lat cat <"(rtos Bgap)">: ")))		; no negative numbers
    (setq Bgap tmp))
  (prompt "\nLenh nay dung de: Cat cac doi tuong duoc chon boi mot doi tuong duoc chon khac.")
  (prompt "\nChon cac doi tuong muon cat roi...")						;;  get objects to break
  (if (and (setq ss1 (ssget '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
           (not (ssredraw ss1 3))
           (not (prompt "\nChon mot doi tuong lam dao cat..."))
           (setq ss2 (ssget "+.:E:S" '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
           (not (ssredraw ss1 4)))
    (break_with ss1 ss2 nil Bgap))								; ss1break ss2breakwith (flag nil = not to break with self)
  (setvar "CMDECHO" cmd) (command "_.undo" "_end") (princ))
;---------- 3. Cat MOT doi tuong DUOC CHON boi CAC doi tuong DUOC CHON khac (Break a single object with other objects)
(defun C:BreakObject (/ cmd ss1 ss2 tmp)
  (command "_.undo" "_begin") (setq cmd (getvar "CMDECHO")) (setvar "CMDECHO" 0)
  (or Bgap (setq Bgap 0))									; default
  (initget 4) (if (setq tmp (getdist (strcat "\nChieu day lat cat <"(rtos Bgap)">: ")))		; no negative numbers
    (setq Bgap tmp))
  (prompt "\nLenh nay dung de: Cat mot doi tuong duoc chon boi cac doi tuong duoc chon khac.")
  (prompt "\nChon mot doi tuong muon cat roi...")						;  get objects to break
  (if (and (setq ss1 (ssget "+.:E:S" '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
           (not (redraw (ssname ss1 0) 3))
           (not (prompt "\nChon cac doi tuong lam dao cat..."))
           (setq ss2 (ssget '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
           (not (redraw (ssname ss1 0) 4)))
     (Break_with ss1 ss2 nil Bgap))								; ss2break ss2breakwith (flag nil = not to break with self)
  (setvar "CMDECHO" cmd) (command "_.undo" "_end") (princ))
;---------- 4. Cat CAC doi tuong DUOC CHON boi CAC doi tuong DUOC CHON khac (Break selected objects with other selected objects)
(defun C:BreakWith (/ cmd ss1 ss2 tmp)
  (command "_.undo" "_begin") (setq cmd (getvar "CMDECHO")) (setvar "CMDECHO" 0)
  (or Bgap (setq Bgap 0))									; default
  (initget 4) (if (setq tmp (getdist (strcat "\nChieu day lat cat <"(rtos Bgap)">: ")))		; no negative numbers
    (setq Bgap tmp))
  (prompt "\nLenh nay dung de: Cat cac doi tuong duoc chon boi cac doi tuong duoc chon khac.")
  (prompt "\nChon cac doi tuong muon cat roi...")
  (if (and (setq ss1 (ssget '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
           (not (ssredraw ss1 3))
           (not (prompt "\nChon cac doi tuong lam dao cat..."))
           (setq ss2 (ssget '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
           (not (ssredraw ss1 4)))
    (break_with ss1 ss2 nil Bgap))								; ss1break ss2breakwith (flag nil = not to break with self)
  (setvar "CMDECHO" cmd) (command "_.undo" "_end") (princ))
;---------- 5. Cat CAC doi tuong BAT KY boi MOT doi tuong DUOC CHON (Break objects touching selected objects)
(defun C:BreakTouching (/ cmd ss1 ss2 tmp)
  (command "_.undo" "_begin") (setq cmd (getvar "CMDECHO")) (setvar "CMDECHO" 0)
  (setq ss1 (ssadd))
  (or Bgap (setq Bgap 0))									; default
  (initget 4) (if (setq tmp (getdist (strcat "\nChieu day lat cat <"(rtos Bgap)">: ")))		; no negative numbers
    (setq Bgap tmp))
  (prompt "\nLenh nay dung de: Cat cac doi tuong bat ky boi mot doi tuong duoc chon.")
  (if (and (not (prompt "\nChon mot doi tuong lam dao cat..."))
           (setq ss2 (ssget '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
           (mapcar '(lambda (x) (ssadd x ss1)) (gettouching ss2)))
    (break_with ss1 ss2 nil Bgap))								; ss1break ss2breakwith (flag nil = not to break with self)
  (setvar "CMDECHO" cmd) (command "_.undo" "_end") (princ))
;---------- 6. Cat CAC doi tuong DUOC CHON boi CAC doi tuong BAT KY (Break selected objects with any objects that touch it)
(defun C:BreakSelected (/ cmd ss1 ss2 tmp)
  (command "_.undo" "_begin") (setq cmd (getvar "CMDECHO")) (setvar "CMDECHO" 0)
  (setq ss1 (ssadd))
  (or Bgap (setq Bgap 0))									; default
  (initget 4) (if (setq tmp (getdist (strcat "\nChieu day lat cat <"(rtos Bgap)">: ")))		; no negative numbers
    (setq Bgap tmp))
  (prompt "\nLenh nay dung de: Cat cac doi tuong duoc chon boi cac doi tuong bat ky.")		;;  get objects to break
  (if (and (not (prompt "\nChon cac doi tuong muon cat roi..."))
           (setq ss2 (ssget '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
           (mapcar '(lambda (x) (ssadd x ss1)) (gettouching ss2)))
    (break_with ss2 ss1 nil Bgap))								; ss2break ss1breakwith (flag nil = not to break with self)
  (setvar "CMDECHO" cmd) (command "_.undo" "_end") (princ))
;---------- 7. Cat CAC doi tuong BAT KY boi CAC doi tuong DUOC CHON (Break touching objects with selected objects. New 08/01/2008)
(defun C:BreakWithTouching (/ cmd ss1 ss2 tmp)
  (command "_.undo" "_begin") (setq cmd (getvar "CMDECHO")) (setvar "CMDECHO" 0)
  (setq ss1 (ssadd))
  (or Bgap (setq Bgap 0))									; default
  (initget 4) (if (setq tmp (getdist (strcat "\nChieu day lat cat <"(rtos Bgap)">: ")))		; no negative numbers
    (setq Bgap tmp))
  (prompt "\nLenh nay dung de: Cat cac doi tuong bat ky boi cac doi tuong duoc chon.")		;;  get objects to break
  (prompt "\nChon cac doi tuong lam dao cat...")
  (if (and (setq ss2 (ssget '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
           (setq tlst (gettouching ss2)))
    (progn
      (setq tlst (vl-remove-if '(lambda (x) (ssmemb x ss2)) tlst))				;  remove if in picked ss
      (mapcar '(lambda (x) (ssadd x ss1)) tlst)							; convert to a selection set
      (break_with ss1 ss2 nil Bgap)))								; ss1break ss2breakwith (flag nil = not to break with self)
  (setvar "CMDECHO" cmd) (command "_.undo" "_end") (princ))
;---------- 8. Cat CAC doi tuong DUOC CHON boi MOT doi tuong KHAC LOP (Break objects with objects on a layer. New 08/01/2008)
(defun C:BreakWlayer (/ cmd ss1 ss2 tmp lay)
  (command "_.undo" "_begin") (setq cmd (getvar "CMDECHO")) (setvar "CMDECHO" 0)
  (or Bgap (setq Bgap 0))									; default
  (initget 4) (if (setq tmp (getdist (strcat "\nChieu day lat cat <"(rtos Bgap)">: ")))		; no negative numbers
    (setq Bgap tmp))
  (prompt "\nLenh nay dung de: Cat cac doi tuong duoc chon boi mot doi tuong khac lop.")
  (prompt "\nChon mot doi tuong de lam lop dao cat...")						;;  get objects to break
  (if (and (setq ss2 (ssget "+.:E:S" '((0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"))))
           (setq lay (assoc 8 (entget (ssname ss2 0))))
           (setq ss2 (ssget "_X" (list '(0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE")
                                       lay (cons 410 (getvar "ctab")))))
           (not (prompt "\nChon cac doi tuong muon cat roi..."))
           (setq ss1 (ssget (list '(0 . "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE")
                                  (cons 8 (strcat "~" (cdr lay)))))))
    (break_with ss1 ss2 nil Bgap))								; ss1break ss2breakwith (flag nil = not to break with self)
  (setvar "CMDECHO" cmd) (command "_.undo" "_end") (princ))
;=============================================== CAC HAM PHU
(vl-load-com)
(defun break_with (ss2brk ss2brkwith self Gap / cmd intpts lst masterlist ss ssobjs onlockedlayer ssget->vla-list list->3pair GetNewEntities oc get_interpts break_obj GetLastEnt LastEntInDatabase ss2brkwithList)
  ;; ss2brk     selection set to break
  ;; ss2brkwith selection set to use as break points
  ;; self       when true will allow an object to break itself note that plined will break at each vertex return list of enames of new objects
  (princ "\nDang tinh cac diem cat. Vui long doi...\n")
;----------
  ;;  return T if entity is on a locked layer
  (defun onlockedlayer (ename / entlst)
    (setq entlst (tblsearch "LAYER" (cdr (assoc 8 (entget ename)))))
    (= 4 (logand 4 (cdr (assoc 70 entlst)))))
  ;;  return a list of objects from a selection set
;|  (defun ssget->vla-list (ss)
    (mapcar 'vlax-ename->vla-object (vl-remove-if 'listp (mapcar 'cadr (ssnamex ss))))
  )|;
  (defun ssget->vla-list (ss / i ename allobj) ; this is faster, changed in ver 1.7
       (setq i -1)
       (while (setq ename (ssname ss (setq i (1+ i))))
         (setq allobj (cons (vlax-ename->vla-object ename) allobj)))
       allobj)
  ;;  return a list of lists grouped by 3 from a flat list
  (defun list->3pair (old / new)
    (while (setq new (cons (list (car old) (cadr old) (caddr old)) new)
                 old (cdddr old)))
    (reverse new))
;---------- return a list of intersect points 
(defun get_interpts (obj1 obj2 / iplist)
  (if (not (vl-catch-all-error-p
             (setq iplist (vl-catch-all-apply
                            'vlax-safearray->list
                            (list
                              (vlax-variant-value
                                (vla-intersectwith obj1 obj2 acextendnone)))))))
    iplist))
;---------- Break entity at break points in list
;;  New as per version 1.8 [BrkGap] --- This subroutine has been re-written
;;  Loop through the break points breaking the entity
;;  If the entity is not a closed entity then a new object is created
;;  This object is added to a list. When break points don't fall on the current 
;;  entity the list of new entities are searched to locate the entity that the 
;;  point is on so it can be broken.
;;  "Break with a Gap" has been added to this routine. The problem faced with 
;;  this method is that sections to be removed may lap if the break points are
;;  too close to each other. The solution is to create a list of break point pairs 
;;  representing the gap to be removed and test to see if there i an overlap. If
;;  there is then merge the break point pairs into one large gap. This way the 
;;  points will always fall on an object with one exception. If the gap is too near
;;  the end of an object one break point will be off the end and therefore that 
;;  point will need to be replaced with the end point.
;;  NOTE: in ACAD2000 the (vlax-curve-getdistatpoint function has proven unreliable
;;  so I have used (vlax-curve-getdistatparam in most cases
(defun break_obj (ent brkptlst BrkGap / brkobjlst en enttype maxparam closedobj
                  minparam obj obj2break p1param p2param brkpt2 dlst idx brkptS
                  brkptE brkpt result GapFlg result ignore dist tmppt
                  #ofpts 2gap enddist lastent obj2break stdist)
  (or BrkGap (setq BrkGap 0.0)) ; default to 0
  (setq BrkGap (/ BrkGap 2.0)) ; if Gap use 1/2 per side of break point
  (setq obj2break ent
        brkobjlst (list ent)
        enttype   (cdr (assoc 0 (entget ent)))
        GapFlg    (not (zerop BrkGap)) ; gap > 0
        closedobj (vlax-curve-isclosed obj2break))
  ;; when zero gap no need to break at end points
  (if (zerop Brkgap)
    (setq spt (vlax-curve-getstartpoint ent)
          ept (vlax-curve-getendpoint ent)
          brkptlst (vl-remove-if '(lambda(x) (or (< (distance x spt) 0.0001)
                                                 (< (distance x ept) 0.0001)))
                                 brkptlst)))
  (if brkptlst
    (progn
  ;;  sort break points based on the distance along the break object
  ;;  get distance to break point, catch error if pt is off end
  ;; ver 2.0 fix - added COND to fix break point is at the end of a
  ;; line which is not a valid break but does no harm
  (setq brkptlst (mapcar '(lambda(x) (list x (vlax-curve-getdistatparam obj2break
                                               ;; ver 2.0 fix
                                               (cond ((vlax-curve-getparamatpoint obj2break x))
                                                   ((vlax-curve-getparamatpoint obj2break
                                                     (vlax-curve-getclosestpointto obj2break x))))))
                            ) brkptlst))
  ;; sort primary list on distance
  (setq brkptlst (vl-sort brkptlst '(lambda (a1 a2) (< (cadr a1) (cadr a2)))))
  (if GapFlg ; gap > 0
    ;; Brkptlst starts as the break point and then a list of pairs of points
    ;;  is creates as the break points
    (progn
      ;;  create a list of list of break points
      ;;  ((idx# stpoint distance)(idx# endpoint distance)...)
      (setq idx 0)
      (foreach brkpt brkptlst
        ;; ----------------------------------------------------------
        ;;  create start break point, then create end break point    
        ;;  ((idx# startpoint distance)(idx# endpoint distance)...)  
        ;; ----------------------------------------------------------
        (setq dist (cadr brkpt)) ; distance to center of gap
        ;;  subtract gap to get start point of break gap
        (cond
          ((and (minusp (setq stDist (- dist BrkGap))) closedobj )
           (setq stdist (+ (vlax-curve-getdistatparam obj2break
                             (vlax-curve-getendparam obj2break)) stDist))
           (setq dlst (cons (list idx
                                  (vlax-curve-getpointatparam obj2break
                                         (vlax-curve-getparamatdist obj2break stDist))
                                  stDist) dlst)))
          ((minusp stDist) ; off start of object so get startpoint
           (setq dlst (cons (list idx (vlax-curve-getstartpoint obj2break) 0.0) dlst)))
          (t
           (setq dlst (cons (list idx
                                  (vlax-curve-getpointatparam obj2break
                                         (vlax-curve-getparamatdist obj2break stDist))
                                  stDist) dlst))))
        ;;  add gap to get end point of break gap
        (cond
          ((and (> (setq stDist (+ dist BrkGap))
                   (setq endDist (vlax-curve-getdistatparam obj2break
                                     (vlax-curve-getendparam obj2break)))) closedobj)
           (setq stdist (- stDist endDist))
           (setq dlst (cons (list idx
                                  (vlax-curve-getpointatparam obj2break
                                         (vlax-curve-getparamatdist obj2break stDist))
                                  stDist) dlst)) )
          ((> stDist endDist) ; off end of object so get endpoint
           (setq dlst (cons (list idx
                                  (vlax-curve-getpointatparam obj2break
                                        (vlax-curve-getendparam obj2break))
                                  endDist) dlst)))
          (t
           (setq dlst (cons (list idx
                                  (vlax-curve-getpointatparam obj2break
                                         (vlax-curve-getparamatdist obj2break stDist))
                                  stDist) dlst))))
        ;; -------------------------------------------------------
        (setq idx (1+ IDX))) ; foreach brkpt brkptlst
      (setq dlst (reverse dlst))
      ;;  remove the points of the gap segments that overlap
      (setq idx -1
            2gap (* BrkGap 2)
            #ofPts (length Brkptlst))
      (while (<= (setq idx (1+ idx)) #ofPts)
        (cond
          ((null result) ; 1st time through
           (setq result (list (car dlst)) ; get first start point
                 result (cons (nth (1+(* idx 2)) dlst) result)))
          ((= idx #ofPts) ; last pass, check for wrap
           (if (and closedobj (> #ofPts 1)
                    (<= (+(- (vlax-curve-getdistatparam obj2break
                            (vlax-curve-getendparam obj2break))
                          (cadr (last BrkPtLst))) (cadar BrkPtLst)) 2Gap))
             (progn
               (if (zerop (rem (length result) 2))
                 (setq result (cdr result)) ; remove the last end point
               )
               ;;  ignore previous endpoint and present start point
               (setq result (cons (cadr (reverse result)) result) ; get last end point
                     result (cdr (reverse result))
                     result (reverse (cdr result))))))
          ;; Break Gap Overlaps
          ((< (cadr (nth idx Brkptlst)) (+ (cadr (nth (1- idx) Brkptlst)) 2Gap))
           (if (zerop (rem (length result) 2))
             (setq result (cdr result)) ; remove the last end point
           )
           ;;  ignore previous endpoint and present start point
           (setq result (cons (nth (1+(* idx 2)) dlst) result)) ; get present end point
           )
          ;; Break Gap does Not Overlap previous point 
          (t
           (setq result (cons (nth (* idx 2) dlst) result)) ; get this start point
           (setq result (cons (nth (1+(* idx 2)) dlst) result)) ; get this end point
          )
        ) ; end cond stmt
      ) ; while
      ;;  setup brkptlst with pair of break pts ((p1 p2)(p3 p4)...)
      ;;  one of the pair of points will be on the object that
      ;;  needs to be broken
      (setq dlst     (reverse result)
            brkptlst nil)
      (while dlst ; grab the points only
        (setq brkptlst (cons (list (cadar dlst)(cadadr dlst)) brkptlst)
              dlst (cddr dlst)))))
  ;; (if (equal a ent) (princ)) ; debug CAB
  (foreach brkpt (reverse brkptlst)
    (if GapFlg ; gap > 0
      (setq brkptS (car brkpt)
            brkptE (cadr brkpt))
      (setq brkptS (car brkpt)
            brkptE brkptS))
    ;;  get last entity created via break in case multiple breaks
    (if brkobjlst
      (progn
        (setq tmppt brkptS) ; use only one of the pair of breakpoints
        ;;  if pt not on object x, switch objects
        (if (not (numberp (vl-catch-all-apply 'vlax-curve-getdistatpoint (list obj2break tmppt))))
          (progn ; find the one that pt is on
            (setq idx (length brkobjlst))
            (while (and (not (minusp (setq idx (1- idx))))
                        (setq obj (nth idx brkobjlst))
                        (if (numberp (vl-catch-all-apply 'vlax-curve-getdistatpoint (list obj tmppt)))
                          (null (setq obj2break obj))						; switch objects, null causes exit
                          t)))))))
    ;| ;; ver 2.0 fix - removed this code as there are cases where the break point
       ;; is at the end of a line which is not a valid break but does no harm
    (if (and brkobjlst idx (minusp idx)
             (null (alert (strcat "Error - point not on object"
                                  "\nPlease report this error to"
                                  "\n   CAB at TheSwamp.org"))))
      (exit))
    |;
    ;; (if (equal (if (null a)(setq a (car(entsel"\nTest Ent"))) a) ent) (princ)) ; debug CAB  -------------
    ;;  Handle any objects that can not be used with the Break Command
    ;;  using one point, gap of 0.000001 is used
    (setq closedobj (vlax-curve-isclosed obj2break))
    (if GapFlg ; gap > 0
      (if closedobj
        (progn ; need to break a closed object
          (setq brkpt2 (vlax-curve-getPointAtDist obj2break
                     (- (vlax-curve-getDistAtPoint obj2break brkptE) 0.00001)))
          (command "._break" obj2break "_non" (trans brkpt2 0 1)
                   "_non" (trans brkptE 0 1))
          (and (= "CIRCLE" enttype) (setq enttype "ARC"))
          (setq BrkptE brkpt2)))
      ;;  single breakpoint ----------------------------------------------------
      ;|(if (and closedobj ; problems with ACAD200 & this code
               (not (setq brkptE (vlax-curve-getPointAtDist obj2break
                       (+ (vlax-curve-getDistAtPoint obj2break brkptS) 0.00001)))))
        (setq brkptE (vlax-curve-getPointAtDist obj2break
                       (- (vlax-curve-getDistAtPoint obj2break brkptS) 0.00001)))
        
      )|;
      (if (and closedobj 
               (not (setq brkptE (vlax-curve-getPointAtDist obj2break
                       (+ (vlax-curve-getdistatparam obj2break
                            ;;(vlax-curve-getparamatpoint obj2break brkpts)) 0.00001))))
                            ;; ver 2.0 fix
                            (cond ((vlax-curve-getparamatpoint obj2break brkpts))
                                  ((vlax-curve-getparamatpoint obj2break
                                      (vlax-curve-getclosestpointto obj2break brkpts))))) 0.00001)))))
        (setq brkptE (vlax-curve-getPointAtDist obj2break
                       (- (vlax-curve-getdistatparam obj2break
                            ;;(vlax-curve-getparamatpoint obj2break brkpts)) 0.00001)))
                            ;; ver 2.0 fix
                            (cond ((vlax-curve-getparamatpoint obj2break brkpts))
                                  ((vlax-curve-getparamatpoint obj2break
                                      (vlax-curve-getclosestpointto obj2break brkpts))))) 0.00001)))))	; endif
    (setq LastEnt (GetLastEnt))									;; (if (null brkptE) (princ)) ; debug
    (command "._break" obj2break "_non" (trans brkptS 0 1) "_non" (trans brkptE 0 1))
    (and *BrkVerbose* (princ (setq *brkcnt* (1+ *brkcnt*))) (princ "\r"))
    (and (= "CIRCLE" enttype) (setq enttype "ARC"))
    (if (and (not closedobj) (not (equal LastEnt (entlast))))					; new object was created
        (setq brkobjlst (cons (entlast) brkobjlst)))))))					; endif brkptlst; defun break_obj
;---------- CAB - get last entity in datatbase
(defun GetLastEnt ( / ename result )
  (if (setq result (entlast))
    (while (setq ename (entnext result))
      (setq result ename)))
  result)
;---------- CAB - return a list of new enames
(defun GetNewEntities (ename / new)
  (cond
    ((null ename) (alert "Ename nil"))
    ((eq 'ENAME (type ename))
      (while (setq ename (entnext ename))
        (if (entget ename) (setq new (cons ename new)))))
    ((alert "Ename wrong type."))) new)
;----------
    (setq LastEntInDatabase (GetLastEnt))
    (if (and ss2brk ss2brkwith)
    (progn
      (setq oc 0 ss2brkwithList (ssget->vla-list ss2brkwith))
      (if (> (* (sslength ss2brk)(length ss2brkwithList)) 5000)
        (setq *BrkVerbose* t))
      (and *BrkVerbose*
           (princ (strcat "Cac doi tuong duoc kiem tra: "
            (itoa (* (sslength ss2brk) (length ss2brkwithList))) "\n")))
      (foreach obj (ssget->vla-list ss2brk)							;;  CREATE a list of entity & it's break points; check each object in ss2brk
        (if (not (onlockedlayer (vlax-vla-object->ename obj)))
          (progn
            (setq lst nil)
            (foreach intobj  ss2brkwithList							;; check for break pts with other objects in ss2brkwith
              (if (and (or self (not (equal obj intobj)))
                       (setq intpts (get_interpts obj intobj)))
                (setq lst (append (list->3pair intpts) lst)))					; entity w/ break points
              (and *BrkVerbose* (princ (strcat "Cac doi tuong kiem tra: " (itoa (setq oc (1+ oc))) "\r"))))
            (if lst (setq masterlist (cons (cons (vlax-vla-object->ename obj) lst) masterlist))))))
      (and *BrkVerbose* (princ "\nDang cat cac doi tuong.\n"))
      (setq *brkcnt* 0)										; break counter
      (if masterlist										;;  masterlist = ((ent brkpts)(ent brkpts)...)
        (foreach obj2brk masterlist
          (break_obj (car obj2brk) (cdr obj2brk) Gap)))))
;----------
;   (and (zerop *brkcnt*) (princ "\nKhong the cat."))
   (setq *BrkVerbose* nil)
  (GetNewEntities LastEntInDatabase))								; return list of enames of new objects
;---------- Redraw ss with mode 
(defun ssredraw (ss mode / i num)
  (setq i -1)
  (while (setq ename (ssname ss (setq i (1+ i))))
    (redraw (ssname ss i) mode)))
;----------Get all objects touching entities in the sscross limited obj types to "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE"  returns a list of enames
  (defun gettouching (sscros / ss lst lstb lstc objl)
    (and
      (setq lstb (vl-remove-if 'listp (mapcar 'cadr (ssnamex sscros))) objl (mapcar 'vlax-ename->vla-object lstb))
      (setq ss (ssget "_A" (list (cons 0 "LINE,ARC,SPLINE,LWPOLYLINE,POLYLINE,CIRCLE,ELLIPSE") (cons 410 (getvar "ctab")))))
      (setq lst (vl-remove-if 'listp (mapcar 'cadr (ssnamex ss))))
      (setq lst (mapcar 'vlax-ename->vla-object lst))
      (mapcar
        '(lambda (x)
           (mapcar
             '(lambda (y)
                (if (not
                      (vl-catch-all-error-p
                        (vl-catch-all-apply
                          '(lambda ()
                             (vlax-safearray->list
                               (vlax-variant-value
                                 (vla-intersectwith y x acextendnone)))))))
                  (setq lstc (cons (vlax-vla-object->ename x) lstc)))) objl)) lst)) lstc)
;--------------------------------------------------------------------------------------------------------------------------------------------------
